function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import IconFont from "../../../iconfont";
import { Form, Input, Popover, message } from "antd";
import React, { useMemo, useState } from "react";
import SelectField from "../SelectField";
import "./index.less";
import { useSharedState } from "../../../../hooks";
import { Context } from "../../model";
var AddFieldModal = function AddFieldModal() {
  var _useSharedState = useSharedState(Context),
    state = _useSharedState.state,
    dispatch = _useSharedState.dispatch;
  var dataSource = state.dataSource,
    defaultColumns = state.defaultColumns;
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var _useState = useState(2),
    _useState2 = _slicedToArray(_useState, 2),
    count = _useState2[0],
    setCount = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    openModal = _useState4[0],
    setOpenModal = _useState4[1];
  var addField = function addField(values) {
    var field_name = values.field_name;
    if (defaultColumns.find(function (d) {
      return d.dataIndex === field_name;
    })) {
      message.warning("This field already exists");
      return;
    }
    var newField = {
      title: field_name,
      dataIndex: field_name,
      editable: true,
      width: 200,
      field_type: values.field_type
    };
    dispatch({
      type: "setDefaultColumns",
      payload: [].concat(_toConsumableArray(defaultColumns), [newField])
    });
    dispatch({
      type: "setDataSource",
      payload: dataSource.map(function (d) {
        return _objectSpread(_objectSpread({}, d), {}, _defineProperty({}, field_name, values.default_value));
      })
    });
    setCount(count + 1);
    onCloseModal();
  };
  var addFieldModal = useMemo(function () {
    return /*#__PURE__*/React.createElement(Form, {
      layout: "vertical",
      form: form,
      onValuesChange: function onValuesChange(e) {
        console.log(e);
      },
      onFinish: addField
    }, /*#__PURE__*/React.createElement("div", {
      className: "pisell-lowcode-add-field-modal"
    }, /*#__PURE__*/React.createElement(Form.Item, {
      label: "Field Name",
      name: "field_name",
      rules: [{
        required: true,
        message: "Please enter a field name"
      }]
    }, /*#__PURE__*/React.createElement(Input, {
      placeholder: "Field name (optional)",
      className: "pisell-lowcode-header-search"
    })), /*#__PURE__*/React.createElement(SelectField, null), /*#__PURE__*/React.createElement("div", {
      className: "pisell-lowcode-modal-footer"
    }, /*#__PURE__*/React.createElement("div", {
      className: "pisell-lowcode-add-describe"
    }, /*#__PURE__*/React.createElement(IconFont, {
      type: "pi-Plus",
      className: "pisell-lowcode-icon"
    }), /*#__PURE__*/React.createElement("span", {
      className: "pisell-lowcode-label"
    }, "Add description")), /*#__PURE__*/React.createElement("div", {
      className: "pisell-lowcode-btns"
    }, /*#__PURE__*/React.createElement("div", {
      className: "pisell-lowcode-cancel",
      onClick: function onClick() {
        onCloseModal();
      }
    }, "Cancel"), /*#__PURE__*/React.createElement("div", {
      className: "pisell-lowcode-submit",
      onClick: function onClick() {
        form.submit();
      }
    }, "Submit")))));
  }, [openModal, form]);
  var onCloseModal = function onCloseModal() {
    form.resetFields();
    setOpenModal(false);
  };
  return /*#__PURE__*/React.createElement(Popover, {
    content: addFieldModal,
    placement: "bottomRight",
    overlayInnerStyle: {
      padding: 0
    },
    trigger: "click",
    overlayClassName: "pisell-lowcode-popover-wrap",
    onOpenChange: function onOpenChange(e) {
      if (!e) {
        onCloseModal();
      } else {
        setOpenModal(true);
      }
    },
    open: openModal
  }, /*#__PURE__*/React.createElement("div", {
    className: "pisell-lowcode-add-field-btn"
  }, /*#__PURE__*/React.createElement(IconFont, {
    type: "pi-a-Property3Add",
    className: "pisell-lowcode-add-field-icon"
  })));
};
export default AddFieldModal;